---  sparc64/include/param.h.orig
+++  sparc64/include/param.h
@@ -105,6 +105,21 @@
 #define PAGE_SIZE_MAX	PAGE_SIZE_4M
 #define PAGE_MASK_MAX	PAGE_MASK_4M
 
+/*
+ * SP_LEVELS is the number of superpage sizes.
+ */
+#define	SP_LEVELS	3
+
+/*
+ * SP_SMALL_SHIFT is LOG2("The Smallest Superpage Size" / PAGE_SIZE).
+ */
+#define	SP_SMALL_SHIFT	3
+
+/*
+ * SP_FACTOR_SHIFT is ...
+ */
+#define	SP_FACTOR_SHIFT	3
+
 #ifndef KSTACK_PAGES
 #define KSTACK_PAGES		4	/* pages of kernel stack (with pcb) */
 #endif
---  sparc64/include/vmparam.h.orig
+++  sparc64/include/vmparam.h
@@ -96,9 +96,10 @@
  * the pool from which physical pages for small UMA objects are
  * allocated.
  */
-#define	VM_NFREEPOOL		2
+#define	VM_NFREEPOOL		3
 #define	VM_FREEPOOL_DEFAULT	0
 #define	VM_FREEPOOL_DIRECT	1
+#define	VM_FREEPOOL_RESERV	2
 
 /*
  * Create two free page lists: VM_FREELIST_DEFAULT is for physical
@@ -215,6 +216,13 @@
 #endif
 
 /*
+ * The default virtual address for the beginning of the text segment
+ */
+#ifndef	VM_IMAGE_BASE
+#define	VM_IMAGE_BASE		(0x0000000100000000UL)
+#endif
+
+/*
  * Initial pagein size of beginning of executable file.
  */
 #ifndef	VM_INITIAL_PAGEIN
---  sparc64/sparc64/pmap.c.orig
+++  sparc64/sparc64/pmap.c
@@ -1262,8 +1262,8 @@
  * will be wired down.
  */
 void
-pmap_enter(pmap_t pm, vm_offset_t va, vm_page_t m, vm_prot_t prot,
-	   boolean_t wired)
+pmap_enter(pmap_t pm, vm_offset_t va, vm_prot_t fault_type, vm_page_t m,
+    vm_prot_t prot, boolean_t wired)
 {
 
 	vm_page_lock_queues();
---  sun4v/include/param.h.orig
+++  sun4v/include/param.h
@@ -102,6 +102,21 @@
 #define PAGE_SIZE_MAX	PAGE_SIZE_4M
 #define PAGE_MASK_MAX	PAGE_MASK_4M
 
+/*
+ * SP_LEVELS is the number of superpage sizes.
+ */
+#define	SP_LEVELS	3
+
+/*
+ * SP_SMALL_SHIFT is LOG2("The Smallest Superpage Size" / PAGE_SIZE).
+ */
+#define	SP_SMALL_SHIFT	3
+
+/*
+ * SP_FACTOR_SHIFT is ...
+ */
+#define	SP_FACTOR_SHIFT	3
+
 #ifndef KSTACK_PAGES
 #define KSTACK_PAGES		4	/* pages of kernel stack (with pcb) */
 #endif
---  sun4v/include/vmparam.h.orig
+++  sun4v/include/vmparam.h
@@ -96,9 +96,10 @@
  * the pool from which physical pages for small UMA objects are
  * allocated.
  */
-#define	VM_NFREEPOOL		2
+#define	VM_NFREEPOOL		3
 #define	VM_FREEPOOL_DEFAULT	0
 #define	VM_FREEPOOL_DIRECT	1
+#define	VM_FREEPOOL_RESERV	2
 
 /*
  * Create two free page lists: VM_FREELIST_DEFAULT is for physical
@@ -215,6 +216,13 @@
 #endif
 
 /*
+ * The default virtual address for the beginning of the text segment
+ */
+#ifndef	VM_IMAGE_BASE
+#define	VM_IMAGE_BASE		(0x0000000100000000UL)
+#endif
+
+/*
  * Initial pagein size of beginning of executable file.
  */
 #ifndef	VM_INITIAL_PAGEIN
---  sun4v/sun4v/pmap.c.orig
+++  sun4v/sun4v/pmap.c
@@ -57,7 +57,7 @@
 #include <vm/vm_object.h>
 #include <vm/vm_extern.h>
 #include <vm/vm_pageout.h>
-#include <vm/vm_pager.h>
+#include <vm/vm_phys.h>
 #include <vm/vm_phys.h>
 #include <vm/uma.h>
 
@@ -1039,7 +1039,8 @@
  * will be wired down.
  */
 void
-pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
+pmap_enter(pmap_t pmap, vm_offset_t va, vm_prot_t fault_type, 
+	   vm_page_t m, vm_prot_t prot,
 	   boolean_t wired)
 {
 	vm_paddr_t pa, opa;
@@ -1124,6 +1125,8 @@
 	
 	invlva = FALSE;
 	if ((otte_data & ~(VTD_W|VTD_REF)) != tte_data) {
+		if (fault_type & VM_PROT_WRITE)
+			tte_data |= VTD_W; 
 		if (otte_data & VTD_V) {
 			if (otte_data & VTD_REF) {
 				if (otte_data & VTD_MANAGED) 
@@ -1141,7 +1144,8 @@
 				pmap_invalidate_page(pmap, va, TRUE);
 		}
 	} 
-
+	tte_hash_insert(pmap->pm_hash, va, tte_data|TTE_MINFLAGS|VTD_REF);
+	tsb_set_tte(&pmap->pm_tsb, va, tte_data|TTE_MINFLAGS|VTD_REF, pmap->pm_context);
 
 	tte_hash_insert(pmap->pm_hash, va, tte_data|TTE_MINFLAGS|VTD_REF);
 	/*
---  vm/pmap.h.orig
+++  vm/pmap.h
@@ -95,8 +95,8 @@
 void		 pmap_clear_reference(vm_page_t m);
 void		 pmap_copy(pmap_t, pmap_t, vm_offset_t, vm_size_t, vm_offset_t);
 void		 pmap_copy_page(vm_page_t, vm_page_t);
-void		 pmap_enter(pmap_t, vm_offset_t, vm_page_t, vm_prot_t,
-		    boolean_t);
+void		 pmap_enter(pmap_t, vm_offset_t, vm_prot_t, vm_page_t,
+		    vm_prot_t, boolean_t);
 void	 pmap_enter_quick(pmap_t pmap, vm_offset_t va, vm_page_t m,
 		    vm_prot_t prot);
 void		 pmap_enter_object(pmap_t pmap, vm_offset_t start,
---  vm/vm.h.orig
+++  vm/vm.h
@@ -114,6 +114,9 @@
 typedef struct vm_page *vm_page_t;
 #endif				/* _KERNEL */
 
+struct vm_reserv;
+typedef struct vm_reserv *vm_reserv_t;
+
 /*
  * Information passed from the machine-independant VM initialization code
  * for use by machine-dependant code (mainly for MMU support)
---  vm/vm_fault.c.orig
+++  vm/vm_fault.c
@@ -117,6 +117,17 @@
 #define VM_FAULT_READ_BEHIND 7
 #define VM_FAULT_READ (VM_FAULT_READ_AHEAD+VM_FAULT_READ_BEHIND+1)
 
+SYSCTL_NODE(_debug, OID_AUTO, prefetch, CTLFLAG_RD, 0, "");
+
+static int aligned = 1;
+SYSCTL_INT(_debug_prefetch, OID_AUTO, aligned, CTLFLAG_RW, &aligned, 0, "");
+
+static int calls;
+SYSCTL_INT(_debug_prefetch, OID_AUTO, calls, CTLFLAG_RD, &calls, 0, "");
+
+static int pages;
+SYSCTL_INT(_debug_prefetch, OID_AUTO, pages, CTLFLAG_RD, &pages, 0, "");
+
 struct faultstate {
 	vm_page_t m;
 	vm_object_t object;
@@ -209,10 +220,10 @@
 {
 	vm_prot_t prot;
 	int is_first_object_locked, result;
-	boolean_t growstack, wired;
+	boolean_t are_queues_locked, growstack, wired;
 	int map_generation;
 	vm_object_t next_object;
-	vm_page_t marray[VM_FAULT_READ];
+	vm_page_t marray[VM_FAULT_READ], mt;
 	int hardfault;
 	int faultcount;
 	struct faultstate fs;
@@ -442,6 +453,10 @@
 			 */
 			fs.m = NULL;
 			if (!vm_page_count_severe()) {
+				if ((fs.object->flags & OBJ_SUPERPAGES) == 0) {
+					fs.object->flags |= OBJ_SUPERPAGES;
+					fs.object->pg_color = atop(vaddr) - fs.pindex;
+				}
 				fs.m = vm_page_alloc(fs.object, fs.pindex,
 				    (fs.vp || fs.object->backing_object)? VM_ALLOC_NORMAL: VM_ALLOC_ZERO);
 			}
@@ -471,6 +486,17 @@
 			if (behavior == MAP_ENTRY_BEHAV_RANDOM) {
 				ahead = 0;
 				behind = 0;
+			} else if (aligned) {
+				/*
+				 * Compute an aligned window of VM_FAULT_READ
+				 * pages that are ahead and/or behind the
+				 * faulting virtual address.
+				 */
+				ahead = atop(MIN(roundup2(vaddr + PAGE_SIZE,
+				    VM_FAULT_READ * PAGE_SIZE), fs.entry->end) -
+				    (vaddr + PAGE_SIZE));
+				behind = atop(vaddr - MAX(fs.entry->start,
+				    vaddr & ~(VM_FAULT_READ * PAGE_SIZE - 1)));
 			} else {
 				behind = (vaddr - fs.entry->start) >> PAGE_SHIFT;
 				if (behind > VM_FAULT_READ_BEHIND)
@@ -480,6 +506,8 @@
 				if (ahead > VM_FAULT_READ_AHEAD)
 					ahead = VM_FAULT_READ_AHEAD;
 			}
+			KASSERT(behind + ahead < VM_FAULT_READ,
+			    ("vm_fault: reading too many pages"));
 			is_first_object_locked = FALSE;
 			if ((behavior == MAP_ENTRY_BEHAV_SEQUENTIAL ||
 			     (behavior != MAP_ENTRY_BEHAV_RANDOM &&
@@ -495,20 +523,26 @@
 				else
 					firstpindex = fs.first_pindex - 2 * VM_FAULT_READ;
 
-				vm_page_lock_queues();
+				mt = fs.first_object == fs.object ? fs.m :
+				    fs.first_m;
+				KASSERT(mt != NULL, ("vm_fault: missing mt"));
+				are_queues_locked = FALSE;
+
 				/*
 				 * note: partially valid pages cannot be 
 				 * included in the lookahead - NFS piecemeal
 				 * writes will barf on it badly.
 				 */
 				for (tmppindex = fs.first_pindex - 1;
-					tmppindex >= firstpindex;
-					--tmppindex) {
-					vm_page_t mt;
-
-					mt = vm_page_lookup(fs.first_object, tmppindex);
-					if (mt == NULL || (mt->valid != VM_PAGE_BITS_ALL))
+				    tmppindex >= firstpindex && (mt =
+				    TAILQ_PREV(mt, pglist, listq)) != NULL &&
+				    mt->pindex == tmppindex; --tmppindex) {
+					if (mt->valid != VM_PAGE_BITS_ALL)
 						break;
+					if (!are_queues_locked) {
+						are_queues_locked = TRUE;
+						vm_page_lock_queues();
+					}
 					if (mt->busy ||
 					    (mt->oflags & VPO_BUSY) ||
 					    (mt->flags & (PG_FICTITIOUS | PG_UNMANAGED)) ||
@@ -522,9 +556,12 @@
 						vm_page_cache(mt);
 					}
 				}
-				vm_page_unlock_queues();
-				ahead += behind;
-				behind = 0;
+				if (are_queues_locked)
+					vm_page_unlock_queues();
+				if (!aligned) {
+					ahead += behind;
+					behind = 0;
+				}
 			}
 			if (is_first_object_locked)
 				VM_OBJECT_UNLOCK(fs.first_object);
@@ -545,8 +582,10 @@
 			 * XXX vm_fault_additional_pages() can block
 			 * without releasing the map lock.
 			 */
+			calls++;
 			faultcount = vm_fault_additional_pages(
 			    fs.m, behind, ahead, marray, &reqpage);
+			pages += faultcount;
 
 			/*
 			 * update lastr imperfectly (we do not know how much
@@ -891,7 +930,7 @@
 	 * back on the active queue until later so that the pageout daemon
 	 * won't find it (yet).
 	 */
-	pmap_enter(fs.map->pmap, vaddr, fs.m, prot, wired);
+	pmap_enter(fs.map->pmap, vaddr, fault_type, fs.m, prot, wired);
 	if (((fault_flags & VM_FAULT_WIRE_MASK) == 0) && (wired == 0)) {
 		vm_fault_prefault(fs.map->pmap, vaddr, fs.entry);
 	}
@@ -987,7 +1026,6 @@
 			break;
 		}
 		if (((m->valid & VM_PAGE_BITS_ALL) == VM_PAGE_BITS_ALL) &&
-			(m->busy == 0) &&
 		    (m->flags & PG_FICTITIOUS) == 0) {
 
 			vm_page_lock_queues();
@@ -1121,6 +1159,8 @@
 	 */
 	dst_object = vm_object_allocate(OBJT_DEFAULT,
 	    OFF_TO_IDX(dst_entry->end - dst_entry->start));
+	dst_object->flags |= OBJ_SUPERPAGES;
+	dst_object->pg_color = atop(dst_entry->start);
 
 	VM_OBJECT_LOCK(dst_object);
 	dst_entry->object.vm_object = dst_object;
@@ -1178,9 +1218,10 @@
 		VM_OBJECT_UNLOCK(dst_object);
 
 		/*
-		 * Enter it in the pmap...
+		 * Enter it in the pmap as if a read fault occurred.
 		 */
-		pmap_enter(dst_map->pmap, vaddr, dst_m, prot, FALSE);
+		pmap_enter(dst_map->pmap, vaddr, prot & ~VM_PROT_WRITE, dst_m,
+		    prot, FALSE);
 
 		/*
 		 * Mark it no longer busy, and put it on the active list.
---  vm/vm_kern.c.orig
+++  vm/vm_kern.c
@@ -406,7 +406,7 @@
 		/*
 		 * Because this is kernel_pmap, this call will not block.
 		 */
-		pmap_enter(kernel_pmap, addr + i, m, VM_PROT_ALL, 1);
+		pmap_enter(kernel_pmap, addr + i, VM_PROT_ALL, m, VM_PROT_ALL, 1);
 		vm_page_wakeup(m);
 	}
 	VM_OBJECT_UNLOCK(kmem_object);
---  vm/vm_object.c.orig
+++  vm/vm_object.c
@@ -90,6 +90,7 @@
 #include <vm/swap_pager.h>
 #include <vm/vm_kern.h>
 #include <vm/vm_extern.h>
+#include <vm/vm_reserv.h>
 #include <vm/uma.h>
 
 #define EASY_SCAN_FACTOR       8
@@ -237,10 +238,14 @@
 	VM_OBJECT_LOCK_INIT(&kernel_object_store, "kernel object");
 	_vm_object_allocate(OBJT_PHYS, OFF_TO_IDX(VM_MAX_KERNEL_ADDRESS - VM_MIN_KERNEL_ADDRESS),
 	    kernel_object);
+	kernel_object->pg_color = (u_short)atop(VM_MIN_KERNEL_ADDRESS);
+	vm_object_set_flag(kernel_object, OBJ_SUPERPAGES);
 
 	VM_OBJECT_LOCK_INIT(&kmem_object_store, "kmem object");
 	_vm_object_allocate(OBJT_PHYS, OFF_TO_IDX(VM_MAX_KERNEL_ADDRESS - VM_MIN_KERNEL_ADDRESS),
 	    kmem_object);
+	kmem_object->pg_color = (u_short)atop(VM_MIN_KERNEL_ADDRESS);
+	vm_object_set_flag(kmem_object, OBJ_SUPERPAGES);
 
 	/*
 	 * The lock portion of struct vm_object must be type stable due
@@ -643,7 +648,7 @@
 			vm_page_free(p);
 			cnt.v_pfree++;
 		} else {
-			vm_page_remove(p);
+			vm_page_remove(p, TRUE);
 		}
 	}
 	vm_page_unlock_queues();
@@ -1244,7 +1249,10 @@
 		LIST_INSERT_HEAD(&source->shadow_head, result, shadow_list);
 		source->shadow_count++;
 		source->generation++;
-		result->flags |= source->flags & OBJ_NEEDGIANT;
+		result->pg_color = (source->pg_color + OFF_TO_IDX(*offset)) &
+		    ((1 << (VM_NFREEORDER - 1)) - 1);
+		result->flags |= source->flags &
+		    (OBJ_NEEDGIANT | OBJ_SUPERPAGES);
 		VM_OBJECT_UNLOCK(source);
 	}
 
@@ -1458,6 +1466,7 @@
 		 */
 		if (op & (OBSC_COLLAPSE_WAIT | OBSC_COLLAPSE_NOWAIT)) {
 			vm_page_t pp;
+			vm_reserv_t reserv;
 
 			if (op & OBSC_COLLAPSE_NOWAIT) {
 				if ((p->oflags & VPO_BUSY) ||
@@ -1519,7 +1528,7 @@
 				if (p->wire_count == 0)
 					vm_page_free(p);
 				else
-					vm_page_remove(p);
+					vm_page_remove(p, TRUE);
 				vm_page_unlock_queues();
 				p = next;
 				continue;
@@ -1543,13 +1552,22 @@
 				if (p->wire_count == 0)
 					vm_page_free(p);
 				else
-					vm_page_remove(p);
+					vm_page_remove(p, TRUE);
 				vm_page_unlock_queues();
 				p = next;
 				continue;
 			}
 
 			/*
+			 * Rename the reservation.
+			 */
+			if ((reserv = vm_reserv_get(p)) != NULL &&
+			    reserv->object != object) {
+				reserv->object = object;
+				reserv->first_pindex -= backing_offset_index;
+			}
+
+			/*
 			 * Page does not exist in parent, rename the
 			 * page from the backing object to the main object. 
 			 *
---  vm/vm_object.h.orig
+++  vm/vm_object.h
@@ -142,6 +142,7 @@
 #define OBJ_PIPWNT	0x0040		/* paging in progress wanted */
 #define OBJ_MIGHTBEDIRTY 0x0100		/* object might be dirty */
 #define OBJ_CLEANING	0x0200
+#define	OBJ_SUPERPAGES	0x1000
 #define	OBJ_ONEMAPPING	0x2000		/* One USE (a single, non-forked) mapping flag */
 #define	OBJ_DISCONNECTWNT 0x4000	/* disconnect from vnode wanted */
 #define	OBJ_NEEDGIANT	0x8000		/* object requires Giant */
---  vm/vm_page.c.orig
+++  vm/vm_page.c
@@ -99,6 +99,8 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/sys/vm/vm_page.c,v 1.348 2007/06/16 04:57:05 alc Exp $");
 
+#include "opt_vm.h"
+
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/lock.h>
@@ -118,6 +120,7 @@
 #include <vm/vm_pageout.h>
 #include <vm/vm_pager.h>
 #include <vm/vm_phys.h>
+#include <vm/vm_reserv.h>
 #include <vm/vm_extern.h>
 #include <vm/uma.h>
 #include <vm/uma_int.h>
@@ -134,7 +137,6 @@
 
 vm_page_t vm_page_array = 0;
 int vm_page_array_size = 0;
-long first_page = 0;
 int vm_page_zero_count = 0;
 
 static int boot_pages = UMA_BOOT_PAGES;
@@ -201,7 +203,7 @@
 vm_page_startup(vm_offset_t vaddr)
 {
 	vm_offset_t mapped;
-	vm_size_t npages;
+	vm_size_t nreservations;
 	vm_paddr_t page_range;
 	vm_paddr_t new_end;
 	int i;
@@ -213,7 +215,7 @@
 	/* the biggest memory array is the second group of pages */
 	vm_paddr_t end;
 	vm_paddr_t biggestsize;
-	vm_paddr_t low_water, high_water;
+	vm_paddr_t high_water;
 	int biggestone;
 
 	vm_paddr_t total;
@@ -229,7 +231,6 @@
 		phys_avail[i + 1] = trunc_page(phys_avail[i + 1]);
 	}
 
-	low_water = phys_avail[0];
 	high_water = phys_avail[1];
 
 	for (i = 0; phys_avail[i + 1]; i += 2) {
@@ -239,8 +240,6 @@
 			biggestone = i;
 			biggestsize = size;
 		}
-		if (phys_avail[i] < low_water)
-			low_water = phys_avail[i];
 		if (phys_avail[i + 1] > high_water)
 			high_water = phys_avail[i + 1];
 		++nblocks;
@@ -273,7 +272,21 @@
 	    VM_PROT_READ | VM_PROT_WRITE);
 	bzero((void *)mapped, end - new_end);
 	uma_startup((void *)mapped, boot_pages);
+	end = new_end;
 
+	/*
+	 * Initialize the reservation structures.
+	 */
+	nreservations = 0;
+	for (i = 0; i < SP_LEVELS; i++)
+		nreservations += total >> (SP_ORDER(i) + PAGE_SHIFT);
+	new_end = end - (nreservations * sizeof(struct vm_reserv));
+	new_end = trunc_page(new_end);
+	mapped = pmap_map(&vaddr, new_end, end, VM_PROT_READ | VM_PROT_WRITE);
+	bzero((void *)mapped, end - new_end);
+	vm_reserv_init((void *)mapped, nreservations);
+	end = new_end;
+
 #if defined(__amd64__) || defined(__i386__)
 	/*
 	 * Allocate a bitmap to indicate that a random physical page
@@ -288,29 +301,27 @@
 	 */
 	page_range = phys_avail[(nblocks - 1) * 2 + 1] / PAGE_SIZE;
 	vm_page_dump_size = round_page(roundup2(page_range, NBBY) / NBBY);
-	new_end -= vm_page_dump_size;
+	new_end = end - vm_page_dump_size;
+	new_end = trunc_page(new_end);
 	vm_page_dump = (void *)(uintptr_t)pmap_map(&vaddr, new_end,
-	    new_end + vm_page_dump_size, VM_PROT_READ | VM_PROT_WRITE);
+	    end, VM_PROT_READ | VM_PROT_WRITE);
 	bzero((void *)vm_page_dump, vm_page_dump_size);
+	end = new_end;
 #endif
 	/*
 	 * Compute the number of pages of memory that will be available for
 	 * use (taking into account the overhead of a page structure per
 	 * page).
 	 */
-	first_page = low_water / PAGE_SIZE;
 #ifdef VM_PHYSSEG_SPARSE
 	page_range = 0;
 	for (i = 0; phys_avail[i + 1] != 0; i += 2)
 		page_range += atop(phys_avail[i + 1] - phys_avail[i]);
 #elif defined(VM_PHYSSEG_DENSE)
-	page_range = high_water / PAGE_SIZE - first_page;
+	page_range = high_water / PAGE_SIZE;
 #else
 #error "Either VM_PHYSSEG_DENSE or VM_PHYSSEG_SPARSE must be defined."
 #endif
-	npages = (total - (page_range * sizeof(struct vm_page)) -
-	    (end - new_end)) / PAGE_SIZE;
-	end = new_end;
 
 	/*
 	 * Reserve an unmapped guard page to trap access to vm_page_array[-1].
@@ -345,14 +356,9 @@
 	vm_page_array_size = page_range;
 
 	/*
-	 * This assertion tests the hypothesis that npages and total are
-	 * redundant.  XXX
+	 * Initialize the physical memory allocator.
 	 */
-	page_range = 0;
-	for (i = 0; phys_avail[i + 1] != 0; i += 2)
-		page_range += atop(phys_avail[i + 1] - phys_avail[i]);
-	KASSERT(page_range == npages,
-	    ("vm_page_startup: inconsistent page counts"));
+	vm_phys_init();
 
 	/*
 	 * Initialize the physical memory allocator.
@@ -697,10 +703,11 @@
  *	This routine may not block.
  */
 void
-vm_page_remove(vm_page_t m)
+vm_page_remove(vm_page_t m, boolean_t release)
 {
 	vm_object_t object;
 	vm_page_t root;
+	vm_reserv_t reserv;
 
 	if ((object = m->object) == NULL)
 		return;
@@ -712,6 +719,12 @@
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 
 	/*
+	 * Release the superpage reservation if specified.
+	 */
+	if ((reserv = vm_reserv_get(m)) != NULL && __predict_false(release))
+		vm_reserv_release(reserv, -1, m);
+
+	/*
 	 * Now remove from the object's list of backed pages.
 	 */
 	if (m != object->root)
@@ -787,8 +800,10 @@
 void
 vm_page_rename(vm_page_t m, vm_object_t new_object, vm_pindex_t new_pindex)
 {
+	vm_reserv_t reserv;
 
-	vm_page_remove(m);
+	vm_page_remove(m, (reserv = vm_reserv_get(m)) != NULL &&
+	    reserv->object != new_object);
 	vm_page_insert(m, new_object, new_pindex);
 	if (VM_PAGE_INQUEUE1(m, PQ_CACHE))
 		vm_page_deactivate(m);
@@ -856,6 +871,7 @@
 vm_page_alloc(vm_object_t object, vm_pindex_t pindex, int req)
 {
 	vm_page_t m = NULL;
+	vm_reserv_t reserv;
 	int flags, page_req;
 
 	page_req = req & VM_ALLOC_CLASS_MASK;
@@ -867,7 +883,9 @@
 		KASSERT(object != NULL,
 		    ("vm_page_alloc: NULL object."));
 		VM_OBJECT_LOCK_ASSERT(object, MA_OWNED);
-	}
+		reserv = vm_reserv_acquire(object, pindex, req);
+	} else
+		reserv = NULL;
 
 	/*
 	 * The pager is allowed to eat deeper into the free page list.
@@ -878,7 +896,14 @@
 
 loop:
 	mtx_lock(&vm_page_queue_free_mtx);
-	if (cnt.v_free_count > cnt.v_free_reserved ||
+	if (reserv != NULL) {
+		KASSERT(!reserv->broken,
+		    ("vm_page_alloc: reservation %p is broken", reserv));
+		m = &reserv->first_page[SP_POS(object, pindex, reserv->level)];
+		KASSERT(m->queue == PQ_NONE,
+		    ("vm_page_alloc: page %p has unexpected queue %d",
+		    m, m->queue));
+	} else if (cnt.v_free_count > cnt.v_free_reserved ||
 	    (page_req == VM_ALLOC_SYSTEM && 
 	     cnt.v_cache_count == 0 && 
 	     cnt.v_free_count > cnt.v_interrupt_free_min) ||
@@ -902,6 +927,14 @@
 			    ("vm_page_alloc: cache queue is missing %d pages",
 			    cnt.v_cache_count));
 			vm_page_unlock_queues();
+
+			/*
+			 * Retry the allocation if the unused pages
+			 * from an incompletely utilized reservation
+			 * are reclaimed.
+			 */ 
+			if (vm_reserv_reclaim(-1))
+				goto loop;
 			atomic_add_int(&vm_pageout_deficit, 1);
 			pagedaemon_wakeup();
 
@@ -966,11 +999,15 @@
 	m->busy = 0;
 	m->valid = 0;
 	KASSERT(m->dirty == 0, ("vm_page_alloc: free/cache page %p was dirty", m));
+	KASSERT(m->reserv == NULL,
+	    ("vm_page_alloc: free page %p has a reservation", m));
 	mtx_unlock(&vm_page_queue_free_mtx);
 
-	if ((req & VM_ALLOC_NOOBJ) == 0)
+	if ((req & VM_ALLOC_NOOBJ) == 0) {
 		vm_page_insert(m, object, pindex);
-	else
+		if (reserv != NULL)
+			vm_reserv_populate(m, reserv);
+	} else
 		m->pindex = pindex;
 
 	/*
@@ -1109,6 +1146,7 @@
 void
 vm_page_free_toq(vm_page_t m)
 {
+	vm_reserv_t reserv;
 
 	if (VM_PAGE_GETQUEUE(m) != PQ_NONE)
 		mtx_assert(&vm_page_queue_mtx, MA_OWNED);
@@ -1134,7 +1172,7 @@
 	 * appropriate free queue.
 	 */
 	vm_pageq_remove_nowakeup(m);
-	vm_page_remove(m);
+	vm_page_remove(m, m->hold_count != 0);
 
 	/*
 	 * If fictitious remove object association and
@@ -1159,16 +1197,20 @@
 		vm_pageq_enqueue(PQ_HOLD, m);
 	} else {
 		m->flags |= PG_FREE;
-		mtx_lock(&vm_page_queue_free_mtx);
-		if ((m->flags & PG_ZERO) != 0) {
-			vm_phys_free_pages_locked(m, 0);
-			++vm_page_zero_count;
-		} else {
-			vm_phys_free_pages_locked(m, 0);
-			vm_page_zero_idle_wakeup();
+		if ((reserv = vm_reserv_get(m)) != NULL)
+			vm_reserv_depopulate(reserv, m);
+		else {
+			mtx_lock(&vm_page_queue_free_mtx);
+			if ((m->flags & PG_ZERO) != 0) {
+				vm_phys_free_pages_locked(m, 0);
+				++vm_page_zero_count;
+			} else {
+				vm_phys_free_pages_locked(m, 0);
+				vm_page_zero_idle_wakeup();
+			}
+			vm_page_free_wakeup();
+			mtx_unlock(&vm_page_queue_free_mtx);
 		}
-		vm_page_free_wakeup();
-		mtx_unlock(&vm_page_queue_free_mtx);
 	}
 }
 
@@ -1710,7 +1752,7 @@
 
  retry_alloc:
 	pmap_remove_all(m);
-	vm_page_remove(m);
+	vm_page_remove(m, TRUE);
 	mnew = vm_page_alloc(object, pindex, VM_ALLOC_NORMAL | VM_ALLOC_NOBUSY);
 	if (mnew == NULL) {
 		vm_page_insert(m, object, pindex);
---  vm/vm_page.h.orig
+++  vm/vm_page.h
@@ -106,6 +106,7 @@
 	struct vm_page *left;		/* splay tree link (O)		*/
 	struct vm_page *right;		/* splay tree link (O)		*/
 
+	vm_reserv_t reserv;		/* which superpage am I in (O) */
 	vm_object_t object;		/* which object am I in (O,P)*/
 	vm_pindex_t pindex;		/* offset into object (O,P) */
 	vm_paddr_t phys_addr;		/* physical address of page */
@@ -254,7 +255,8 @@
 
 extern vm_page_t vm_page_array;		/* First resident page in table */
 extern int vm_page_array_size;		/* number of vm_page_t's */
-extern long first_page;			/* first physical page number */
+
+#define	VM_PAGE_IS_FREE(m)	(((m)->flags & PG_FREE) != 0)
 
 #define	VM_PAGE_IS_FREE(m)	(((m)->flags & PG_FREE) != 0)
 
@@ -270,7 +272,7 @@
 #ifdef VM_PHYSSEG_SPARSE
 	return (vm_phys_paddr_to_vm_page(pa));
 #elif defined(VM_PHYSSEG_DENSE)
-	return (&vm_page_array[atop(pa) - first_page]);
+	return (&vm_page_array[atop(pa)]);
 #else
 #error "Either VM_PHYSSEG_DENSE or VM_PHYSSEG_SPARSE must be defined."
 #endif
@@ -331,7 +333,7 @@
 void vm_page_deactivate (vm_page_t);
 void vm_page_insert (vm_page_t, vm_object_t, vm_pindex_t);
 vm_page_t vm_page_lookup (vm_object_t, vm_pindex_t);
-void vm_page_remove (vm_page_t);
+void vm_page_remove(vm_page_t, boolean_t);
 void vm_page_rename (vm_page_t, vm_object_t, vm_pindex_t);
 vm_page_t vm_page_select_cache(void);
 void vm_page_sleep(vm_page_t m, const char *msg);
---  vm/vm_phys.h.orig
+++  vm/vm_phys.h
@@ -27,7 +27,7 @@
  * WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $FreeBSD: src/sys/vm/vm_phys.h,v 1.1 2007/06/10 00:49:16 alc Exp $
+ * $FreeBSD$
  */
 
 /*
